<?php 
if( !AMXBANS_ACTIVE )
	grey::head( ADDRESS, [ 'err_msg' => 'Бан лист отключен' ] );
$this->title = 'Бан лист сервера';
$this->sesc = 'Бан лист сервера';
$class = 'tr_tables';
$total = bans::total();
$razdel = 10; // всего страниц
$page = ( isset( $_GET['page'] ) ) ? $_GET['page'] : 1;
$start = ( $page - 1 ) * $razdel;
$end = ( $total > $start + $razdel ) ? $start + $razdel : $total; 

$banList = bans::select(
	[ 'bid', 'player_nick', 'admin_nick', 'ban_reason', 'cs_ban_reason', 'ban_created', 'expired', 'server_name' ],
	'', //where
	'bid',
	false,
	"{$start},{$razdel}" //лимит
);
$pagenation = grey::pags( $total, $razdel, grey::url( 'bans' ) );

?>
<div id="main-content">
	<div class="row">
		<div class="col-md-12">
			<div class="panel panel-default">
				<div class="panel-heading">
					<form method="GET" action="<?=grey::url( 'bans')?>" class="form-inline">
							<input type="text" name="search" placeholder="Поиск по бан листу" value="" onkeyup="search_bans(this.value);" autocomplete="off" class="form-control">
					</form>
				</div>
				<div class="panel-body">
					<div class="row">
						<div class="col-md-12 col-sm-12 col-xs-12 table-responsive">
							<div id="search-list-container"></div>
							<table  id="search-container" class="table table-striped table-hover">
								<thead class="no-bd">
									<th>Ник</th>
									<th>Админ</th>
									<th>Причина</th>
									<th>Дата</th>
									<th>Забанен?</th>
								</thead>
								<tbody class="no-bd-y" id="ittems-list">
									<?php if( is_array( $banList ) ) :?>
										<?php for( $i = 0; $i < count( $banList ); $i++ ) : ?>
											<?php include( 'table_ittem.tpl' ); ?>
										<?php endfor ?>
									<?php  endif ?>
								</tbody>
							</table>
							<?php if( !isset( $_GET['where'] ) ) : ?>
							<div class="pull-center" id="search-pages">
								<?=$pagenation?>
							</div>
							<?php endif ?>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<div class="modal fade" id="view_modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title" id="myModalLabel">Информация о бане</h4>
      </div>
      <div class="modal-body">
			Бан игрока <b id="ban_modal"></b> <br />
			Забанил <b id="ban_modal_zabanil"></b> <br />
			Время бана <b id="ban_modal_vremia"></b> <br />
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">
			Закрыть
		</button>
<?php if( isset( $_SESSION['id'] ) && ( $this->userData['group'] == 4 || $this->userData['group'] == 3 ) ) : ?>
        <button type="button" id="seend_delete" class="btn btn-primary">
			Удалить бан
		</button>
<?php endif ?>
<?php if( isset( $_SESSION['id'] )  ) : ?>
        <button type="button" id="seend_zayavka" class="btn btn-primary">
			Отправить заявку на форум
		</button>
<?php endif ?>
      </div>
    </div>
  </div>
</div>

<script>
$('#search-list-container').hide();
$( "#seend_zayavka" ).hide();
$( "#seend_delete" ).hide();
function view_ban( id ) {
	$('#view_modal').modal('show');
	var get_player = $( '#player_nick_' + id ).data( 'player_nick' );
	var admin_nick = $( '#admin_nick_' + id ).data( 'admin_nick' );
	var ban_created = $( '#ban_created_' + id ).data( 'ban_created' );
	var ban_created = $( '#ban_created_' + id ).data( 'ban_created' );
	var expired = $( '#expired_' + id ).data( 'expired' );
	
	if( expired == 0 ) {
		$( "#seend_zayavka" ).show();
		<?php if( isset( $_SESSION['id'] ) && ( $this->userData['group'] == 4 || $this->userData['group'] == 3 ) ) : ?>
		$( "#seend_delete" ).show();
		<?php endif ?>
	}
	
	$( '#ban_modal' ).text( get_player );
	$( '#ban_modal_zabanil' ).text( admin_nick );
	$( '#ban_modal_vremia' ).text( ban_created );
	$( '#myModalLabel' ).text( 'Информация о бане ' + get_player );
<?php if( isset( $_SESSION['id'] ) && ( $this->userData['group'] == 4 || $this->userData['group'] == 3 ) ) : ?>	
	$( "#seend_delete" ).attr( "onclick", 'seend_delete(' + id + ');' );
<?php endif ?>
<?php if( isset( $_SESSION['id'] )  ) : ?>
	$( "#seend_zayavka" ).attr( "onclick", 'seend_zayavka(' + id + ');' );
<?php endif ?>
}
<?php if( isset( $_SESSION['id'] ) && ( $this->userData['group'] == 4 || $this->userData['group'] == 3 ) ) : ?>
function seend_delete( id ) {
	$.get( "<?=ADDRESS?>function.php", { seend_delete_ban: id }, function (data) {
		if( data.status == 1) {
			$('#view_modal').modal('hide');
			$( "#bid_" + id ).hide();
		} 
	});
}
<?php endif ?>
<?php if( isset( $_SESSION['id'] )  ) : ?>
function seend_zayavka( id ) {
	$.get( "<?=ADDRESS?>function.php", { seend_zayavka_bans: id }, function (data) {
		if( data.status == 0 ) {
			$( "#seend_zayavka" ).hide();
		} else {
			document.location = '<?=ADDRESS?>forum/topic?id=' + data.status ;
		}
	});
}
<?php endif ?>


function search_bans( query ) {
    search_wrapper = $('#search-container');
    search_pages = $('#search-pages');
    tr_tables = $('.tr_tables');
	
    if ( query.length == 0 ) { 
		search_wrapper.show();
		search_pages.show();
		$('#search-list-container').hide();
    }
    else  if ( query.length > 3 ){
		 search_wrapper.hide();
		 search_pages.hide();
        $.get( "<?=ADDRESS?>function.php", { search_bans: query }, function (data) {
            if ( data ) {
				search_wrapper.show();
				tr_tables.remove();
				$('#ittems-list').html( data ).show();
            } else  {
				$('#search-list-container').text('Поиск не дал результатов!').show();
            }
        });
    }
}
</script>
