<?php 

if( $this->userData['group'] != 4 )
	grey::head( ADDRESS, [ 'err_msg' => 'Нет доступа' ] );
	
if( isset( $_GET['id'] ) )
	return include( 'server.tpl' );
	
$this->title = 'Менеджер серверов';
$this->desc = 'Менеджер серверов';
if( isset( $_GET[ 'delete' ] ) ) {
	$delete = ( int ) $_GET[ 'delete' ];
	vip_servers::delete( [ 'id' => $delete ] );
	grey::head( grey::url( 'vip/admin' ), [ 'msg' => 'Сервер удален' ] );
}
$vip_servers = vip_servers::selectAdmin();

?>
<div id="main-content">
	<div class="row">
		<div class="col-md-12">
			<div class="panel panel-default">
				<div class="panel-body">
					<div class="row">
						<div class="col-md-12 col-sm-12 col-xs-12 table-responsive">
							<div id="search-list-container"></div>
							<table  id="search-container" class="table table-striped table-hover">
								<thead class="no-bd">
									<th>Имя сервера</th>
									<th>IP адрес / host</th>
									<th></th>
								</thead>
								<tbody class="no-bd-y" id="ittems-list">
									<?php if( is_array( $vip_servers ) ) :?>
										<?php for( $i = 0; $i < count( $vip_servers ); $i++ ) : ?>
											<tr>
												<th>
													<a title="Редактировать сервер" href="<?=grey::url( 'vip/admin', [ 'id' => $vip_servers[$i]['id'] ] )?>"><?=$vip_servers[$i]['server_name']?></a>
												</th>
												<th>
													<?=$vip_servers[$i]['server_ip']?>:<?=$vip_servers[$i]['server_port']?>
												</th>
												<th>
													<a href="<?=grey::url( 'vip/admin', [ 'delete' => $vip_servers[$i]['id'] ] )?>">Удалить</a>
												</th>
											</tr>
										<?php endfor ?>
									<?php  endif ?>
								</tbody>
							</table>
							<button type="button" class="btn btn-primary btn-lg" data-toggle="modal" data-target="#myModal">
								Добавить сервер
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<form method="POST" action="<?=ADDRESS?>function.php">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
					<h4 class="modal-title" id="myModalLabel">Добавление сервера</h4>
				</div>
				<div class="modal-body">
					<div class="form-group">
						<select id="select_method" onchange="select();" name="type" class="form-control">
							<option value="false">Выберите метод</option>
							<option value="0">AMX admin</option>
							<option value="1">FTP users.ini</option>
						</select>
					</div>
				<div id="no_select">
					<div class="form-group">
						<label id="text_host" for="host">IP адрес ftp</label>
						<input required type="text" class="form-control" id="host" name="host">
					</div> 	
					<div class="form-group" id="text_amx_id_hide">
						<label id="text_amx_id" for="amx_id">AMX id server, ИД сервера в AMX bans (оставьте пустым если это не банс)</label>
						<input type="number" class="form-control" id="amx_id" name="amx_id">
					</div> 	
					<div class="form-group">
						<label id="text_user" for="user">user FTP</label>
						<input required type="text" class="form-control" id="user" name="user">
					</div> 	
					<div class="form-group">
						<label id="text_password" for="password">пароль FTP</label>
						<input required type="text" class="form-control" id="password" name="password">
					</div> 	
					<div class="form-group">
						<label id="text_bd" for="bd">путь до users.ini FTP</label>
						<input required type="text" class="form-control" id="bd" name="bd">
					</div> 	
					<div class="form-group" id="text_prefix_hide">
						<label for="prefix">MYSQL префикс</label>
						<input type="text" class="form-control" id="prefix" name="prefix">
					</div> 	
					<div class="form-group">
						<label for="server_name">Название сервера ( Вывод в покупках )</label>
						<input required type="text" class="form-control" id="server_name" name="server_name">
					</div> 	
					<div class="form-group">
						<label for="server_ip">IP сервера ( Вывод в покупках )</label>
						<input required type="text" class="form-control" id="server_ip" name="server_ip">
					</div>  	
					<div class="form-group">
						<label for="server_port">Порт сервера ( Вывод в покупках )</label>
						<input required type="number" class="form-control" id="server_port" name="server_port">
					</div> 
				</div> 
				</div>
				<div class="modal-footer" id="footer_select">
					<button type="button" class="btn btn-default" data-dismiss="modal">
						Отмена
					</button>
					<button class="btn btn-primary">
						Сохранить
					</button>
				
				</div>
				<input type="hidden" name="add_server_vip">
			</form>
		</div>
	</div>
</div>
<script>
$('#no_select').hide();
$('#footer_select').hide();
function select() {
	$('#no_select').hide();
	$('#footer_select').hide();
	var select_method = $('#select_method').val();
	if( select_method == 0 ) {
		$('#text_prefix_hide').show();	
		$('#text_amx_id_hide').show();
		$('#no_select').show();
		$('#footer_select').show();	
		$('#text_host').text( 'MYSQL host' );			
		$('#text_user').text( 'MYSQL user' );			
		$('#text_password').text( 'MYSQL пароль ' );			
		$('#text_bd').text( 'MYSQL База ' );			
	} else if( select_method == 1 ){
		$('#no_select').show();
		$('#footer_select').show();	
		$('#text_host').text( 'FTP IP адрес' );				
		$('#text_user').text( 'FTP user' );			
		$('#text_password').text( 'FTP пароль ' );			
		$('#text_bd').text( 'FTP полный путь до users.ini' );
		$('#text_prefix_hide').hide();	
		$('#text_amx_id_hide').hide();	
	}
}
</script>